import 'package:packme/packme.dart';

class Animal extends PackMeMessage {
	Animal({
		required this.hp,
	});
	Animal.$empty();

	late double hp;

	@override
	int $estimate() {
		$reset();
		return 8;
	}

	@override
	void $pack() {
		$packDouble(hp);
	}

	@override
	void $unpack() {
		hp = $unpackDouble();
	}

	@override
	String toString() {
		return 'Animal\x1b[0m(hp: ${PackMe.dye(hp)})';
	}
}

class AnimalMessage extends PackMeMessage {
	AnimalMessage({
		required this.hp,
	});
	AnimalMessage.$empty();

	late double hp;

	@override
	int $estimate() {
		$reset();
		return 8;
	}

	@override
	void $pack() {
		$packDouble(hp);
	}

	@override
	void $unpack() {
		hp = $unpackDouble();
	}

	@override
	String toString() {
		return 'AnimalMessage\x1b[0m(hp: ${PackMe.dye(hp)})';
	}
}

class Cat extends Animal {
	Cat({
		required double hp,
		required this.color,
	}) : super(hp: hp);
	Cat.$empty() : super.$empty();

	late String color;

	@override
	int $estimate() {
		int _bytes = super.$estimate();
		_bytes += $stringBytes(color);
		return _bytes;
	}

	@override
	void $pack() {
		super.$pack();
		$packString(color);
	}

	@override
	void $unpack() {
		super.$unpack();
		color = $unpackString();
	}

	@override
	String toString() {
		return 'Cat\x1b[0m(color: ${PackMe.dye(color)}) of ${super.toString()}';
	}
}